/* Ppc register context support
 *
 * Copyright (C) 2000 Ulrich Weigand
 */

#include "config.h"

#ifdef __PPC__

#include <assert.h>
#include <errno.h>
#include <sys/types.h>
#ifdef HAVE_SYS_REG_H
#include <sys/reg.h>
#endif
#include <unistd.h>
#include <sys/ptrace.h>
#include <sys/user.h>

#include "winbase.h"

#include "thread.h"
#include "request.h"



/* retrieve a thread context */
static void get_thread_context( struct thread *thread, unsigned int flags, CONTEXT *context )
     {
      int pid = thread->unix_tid_or_pid;
      if (flags & CONTEXT_FULL)
     {
#ifndef __PPC__   /* EZUST - apparently not supported! FIXME */
            if (ptrace( PTRACE_GETREGS, pid, 0, (int) NULL ) == -1) goto error;
#endif
            if (flags & CONTEXT_INTEGER)
       {
                  /* FIXME: local and in registers */
  }
            if (flags & CONTEXT_CONTROL)
       {
            
  }
     }
      if (flags & CONTEXT_FLOATING_POINT)
     {
            /* FIXME */
  }
      return;
   error:
        file_set_error();
    }


/* set a thread context */
static void set_thread_context( struct thread *thread, unsigned int flags, CONTEXT *context )
     {
      /* FIXME */
 }


/* copy a context structure according to the flags */
static void copy_context( CONTEXT *to, CONTEXT *from, int flags )
     {
      if (flags & CONTEXT_CONTROL)
     {
     }
      if (flags & CONTEXT_INTEGER)
     {
     }
      if (flags & CONTEXT_FLOATING_POINT)
     {
            /* FIXME */
  }
  }

/* retrieve the current instruction pointer of a thread */
void *get_thread_ip( struct thread *thread )
     {
      CONTEXT context;
      if (suspend_for_ptrace( thread ))
     {
            get_thread_context( thread, CONTEXT_CONTROL, &context );
            resume_thread( thread );
     }
      return (void *)NULL;
  }


/* determine if we should continue the thread in single-step mode */
int get_thread_single_step( struct thread *thread )
{
  return 0; /* FIXME */
}


/* retrieve the current context of a thread */
DECL_HANDLER(get_thread_context)
     {
      struct thread *thread;
      int flags = req->flags;

        if (get_req_data_size() < sizeof(CONTEXT))
       {
              set_error( STATUS_INVALID_PARAMETER );
              return;
       }
        if ((thread = get_thread_from_handle( req->handle, THREAD_GET_CONTEXT )))
       {
              if (thread->context)  /* thread is inside an exception event */
	 {
	            copy_context( get_req_data(), thread->context, flags );
	            flags = 0;
	 }
              if (flags && suspend_for_ptrace( thread ))
	 {
	            get_thread_context( thread, flags, get_req_data() );
	            resume_thread( thread );
	 }
              release_object( thread );
       }
    }


/* set the current context of a thread */
DECL_HANDLER(set_thread_context)
     {
      struct thread *thread;
      int flags = req->flags;

        if (get_req_data_size() < sizeof(CONTEXT))
       {
              set_error( STATUS_INVALID_PARAMETER );
              return;
       }
        if ((thread = get_thread_from_handle( req->handle, THREAD_SET_CONTEXT )))
       {
              if (thread->context)  /* thread is inside an exception event */
	 {
	            copy_context( thread->context, get_req_data(), flags );
	            flags = 0;
	 }
              if (flags && suspend_for_ptrace( thread ))
	 {
	            set_thread_context( thread, flags, get_req_data() );
	            resume_thread( thread );
	 }
              release_object( thread );
       }
    }

#endif  /* __PPC__ */
